//
//  P4Spec.h
//  P4ObjectLayer
//
//  Created by Michael Bishop on 4/25/11.
//  Copyright 2011 Numerical Garden, LLC. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef void (^SpecRefreshCompletionBlock)(NSError*);

@class P4SpecManager, P4Connection;

@interface P4Spec : NSManagedObject {
@private
    NSString *              _type;
    NSMutableArray *        _completionBlocksForRefresh;
    NSMutableArray *        _completionBlocksForSave;
    BOOL                    _isUpdatingFromRetrievedServerData;
    int                     _isRefreshingFromServer;
    NSSet *                 _mappedSpecKeysCache;
    NSMutableDictionary *   _fetchedPropertyCache;
}

-(NSString*)form;
-(void)refreshWithCompletion:(SpecRefreshCompletionBlock)completion;
-(void)saveWithCompletion:(SpecRefreshCompletionBlock)completion;

-(void)refresh:(id)sender;
-(void)revert:(id)sender;
-(void)save:(id)sender;

@property (readonly, nonatomic) NSTimeInterval refreshInterval;
@property (readonly, nonatomic)       BOOL       isDirty;
@property (readonly, nonatomic, copy) NSString * type;
@property (readonly, nonatomic, copy) NSString * identifier;
@property (readonly, nonatomic) P4SpecManager * manager;
@property (readonly, nonatomic) P4Connection * connection;

// to be private
// enabled for the spec-manager
-(void)updateWithRawData:(NSDictionary*)data;

@end
